import logging
from paircd.reply import MODE, RPL_CHANNELMODEIS

from paircd.client import Client
from paircd.command_handler import CommandHandler
from paircd.message import Message
from paircd.server import Server


class ModeHandler(CommandHandler):
    def __init__(self) -> None:
        super().__init__("MODE")

    async def handle(self, server: Server, client: Client, msg: Message) -> None:
        name = msg.args[0]
        if not name.startswith("#"):
            client.log("TODO: implement user mode queries", level=logging.WARN)
            return

        channel = server.get_channel_by_name(name)
        modes = "".join(channel.get_modes())
        if modes != "":
            modes = f"+{modes}"

        client.log("TODO: implement channel modes", level=logging.WARN)
        client.write_message(MODE(name, modes))
        client.write_message(RPL_CHANNELMODEIS(client.nickname, name, modes, ""))
